﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EF6.Data.CodeFirst
{
	public class CodeFirstContext : DbContext
	{
		public DbSet<Person> People { get; set; }

		protected override void OnModelCreating(DbModelBuilder modelBuilder)
		{
			var prop = modelBuilder.Properties().Where(p => p.Name.Equals("Id" + p.DeclaringType.Name, StringComparison.OrdinalIgnoreCase));
			prop.Configure(p => p.IsKey());
			prop.Configure(p => p.HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity));
			modelBuilder.Conventions.Add<DecimalConvention>();
			modelBuilder.Entity<Person>().MapToStoredProcedures();
		}
	}
}
