﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Data.Entity;
using System.Data.Entity.Infrastructure.Interception;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EF6.Data
{
	public class NorthwindLogFormatter : DatabaseLogFormatter
	{
		public NorthwindLogFormatter(DbContext context, Action<string> writeAction)
			: base(context, writeAction)
		{
		}

		public override void LogCommand<TResult>(DbCommand command, DbCommandInterceptionContext<TResult> interceptionContext)
		{
			Write(String.Format(
					"Command '{0}'{1}",
					command.CommandText.Replace(Environment.NewLine, ""),
					Environment.NewLine));
		}

		public override void ReaderExecuted(DbCommand command, DbCommandInterceptionContext<DbDataReader> interceptionContext)
		{
			var reader = interceptionContext.Result;

			var table = new DataTable();
			for (var i = 0; i < reader.FieldCount; i++)
			{
				table.Columns.Add(new DataColumn(reader.GetName(i), reader.GetFieldType(i)));
			}

			while (reader.Read())
			{
				var row = table.NewRow();
				for (var i = 0; i < reader.FieldCount; i++)
				{
					var columnName = reader.GetName(i);
					row[columnName] = reader[i];
					Debug.Write(String.Format("{0} {1}\r\n", columnName, reader[i]));
				}
				table.Rows.Add(row);
			}
			interceptionContext.Result = table.CreateDataReader();
		}
	}
}
