﻿using System;
using System.Data.Entity;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using System.Diagnostics;
using System.Data.SqlClient;
using EF6.Data;
using System.Data.Entity.Core.EntityClient;

namespace EF6.UI.Controllers
{
	public class DbFirstController : Controller
	{
		public ActionResult Index()
		{
			return View();
		}

		public async Task<ActionResult> Async()
		{
			using (var ctx = new EF6.Data.NorthwindEntities())
			{
				var x = await ctx.Customers.FirstAsync();
				x.Phone = "000-00-9" + DateTime.Now.Second;
				await ctx.SaveChangesAsync();
			}
			return View();
		}

		public ActionResult Connection()
		{
			var builder = new EntityConnectionStringBuilder();
			builder.Metadata = "res://*/Model.csdl|res://*/Model.ssdl|res://*/Model.msl";
			builder.Provider = "System.Data.SqlClient";
			builder.ProviderConnectionString = "data source=Pesaro;initial catalog=Northwind;integrated security=True;MultipleActiveResultSets=True;App=EntityFramework";
			using (var conn = new EntityConnection(builder.ConnectionString))
			{
				conn.Open();
				using (var command = new SqlCommand("SELECT * FROM CUSTOMERS", (SqlConnection)conn.StoreConnection))
				{
					var reader = command.ExecuteReader();
				}
				
				using (var ctx = new NorthwindEntities(conn, false))
				{
					var list = ctx.Customers.ToList();
				}

				using (var command = new SqlCommand("SELECT * FROM CUSTOMERS", (SqlConnection)conn.StoreConnection))
				{
					var reader = command.ExecuteReader();
				}
			}
			return View();
		}

		public ActionResult TransactionFromOuter()
		{
			var builder = new EntityConnectionStringBuilder();
			builder.Metadata = "res://*/Model.csdl|res://*/Model.ssdl|res://*/Model.msl";
			builder.Provider = "System.Data.SqlClient";
			builder.ProviderConnectionString = "data source=Pesaro;initial catalog=Northwind;integrated security=True;MultipleActiveResultSets=True;App=EntityFramework";
			using (var conn = new EntityConnection(builder.ConnectionString)) {
				conn.Open();
				using (var trans = conn.StoreConnection.BeginTransaction())
				{
					using (var ctx = new NorthwindEntities(conn, false))
					{
						var order = new Order()
						{
							CustomerID = "ALFKI",
							OrderDate = DateTime.Now,
							ShipAddress = "address",
							ShipCity = "rome",
							ShipCountry = "Italy",
							ShipName = "Name",
							ShipPostalCode = "00181",
							ShipRegion = "Lazio",
							Order_Details = new HashSet<Order_Detail>()
						};
						order.Order_Details.Add(new Order_Detail
						{
							Discount = 0,
							ProductID = 1,
							Quantity = 1,
							UnitPrice = 10
						});
						ctx.Orders.Add(order);
						ctx.SaveChanges();
					}
					using (var command = new SqlCommand("update products set unitsinstock = unitsinstock - 1 where productid = 1", (SqlConnection)conn.StoreConnection, (SqlTransaction)trans))
					{
						var reader = command.ExecuteNonQuery();
					}
					trans.Commit();
				}
			}
			return View();
		}

		public ActionResult TransactionFromEF()
		{
			using (var ctx = new NorthwindEntities())
			{
				var trans = ctx.Database.BeginTransaction();
				var order = new Order()
				{
					CustomerID = "ALFKI",
					OrderDate = DateTime.Now,
					ShipAddress = "address",
					ShipCity = "rome",
					ShipCountry = "Italy",
					ShipName = "Name",
					ShipPostalCode = "00181",
					ShipRegion = "Lazio",
					Order_Details = new HashSet<Order_Detail>()
				};
				order.Order_Details.Add(new Order_Detail
				{
					Discount = 0,
					ProductID = 1,
					Quantity = 1,
					UnitPrice = 10
				});
				ctx.Orders.Add(order);
				ctx.SaveChanges();
				ctx.Database.ExecuteSqlCommand("update products set unitsinstock = unitsinstock - 1 where productid = 1");
				trans.Commit();
			}
			return View();
		}

		public ActionResult Logging()
		{
			using (var ctx = new EF6.Data.NorthwindEntities())
			{
				ctx.Database.Log = s => Debug.WriteLine(s);
				
				var x = ctx.Customers.First();
				x.Phone = "000-00-9" + DateTime.Now.Second;
				ctx.SaveChanges();
			}
			return View();
		}
	}
}